#include "definitions.h"
#include "OperationGraph.h"

class DistSim
{
	
private:
// define the array towards tasks
	OperationNode* Go;
	float dt;

	int GoSize;
	int *StateExecutable;
	float *Srt;

	int getNodeNumber();
	int getPos(int id);
	void activateSuccessor(int id);
	int requestNumber;
	int *Frequence;
	float *Transit;
	int *Nloop;
	int *NPred;
	double meanTime;

	void setExecutableTask();
	void updateQoSTask();
	void updateExecutableTask();
	void init();
	void setState(int i);
	
	int xorChoice(int max);
	void orChoice(int max, int tab[]);	
	void activateSuccessor(int id, int type);

public:

	DistSim(); // by default, initialize the number of threads to 1 and initialize Solved.
	~DistSim();
	void run();
	void setDelta(float delta);
	void setGraphSize(int size);
	void setOperationNode(OperationNode *ptr);
	void setRequestNumber(int n);	
	double getMeanTime();
	int getFrequence(int node); 
	void deduceOrProba(int f1, int f2, float *p1, float *p2, float *p12);/* Les proba d'excution pour un connecteur OR 
	se calculent comme suit. On a une frquence f1 et f2 pour chaque choix. On sait que la 
	frquence x = (f1+f2)-requestNumber correspond au cas o les deux chemins ont t activ. 
	Ainsi la proba d'excution du premier est f1-x/requestNumber, celle du second f2-x/requestNumber 
	et celle des deux x/requestNumber */
	double getProba(int node); 
};


