#include<iostream>
#include "OperationGraph.h"
using namespace std;

OperationGraph :: OperationGraph(){
	size = 0;
}


OperationGraph :: ~OperationGraph(){

}

void OperationGraph :: loadGraph( char* modelfile, char *datafile){

	int n, nc;
	int id, poolid, i, j, k, l;
	string strType;
	string strMode;
	int type;
	int mode;
	float srt;
	
	ifstream modfile (modelfile, ifstream::in);
	ifstream datfile(datafile, ifstream::in);
	modfile >> n; // n is the number of nodes in the model.
	if(n > 0){
		size = n;
		Nodes = new OperationNode[size];
	}
	// Read nodes and SRT
	for(i = 0; i < n; i++){
		modfile >> id >> poolid >> strType >> strMode;
		Nodes[i].task = new BPMNUnitTask();
		Nodes[i].task->setId(id);
		Nodes[i].task->setPool(poolid);
		
/*		Nodes[i].succs = NULL;
		Nodes[i].sender = NULL;
		Nodes[i].predLoop = NULL;
		Nodes[i].srtTransit = NULL;
		Nodes[i].orSplit = NULL;
*/		
		if(strType.compare("OPERATION") == 0){
			datfile >> srt;
			Nodes[i].task->setSrt(srt);
			Nodes[i].task->setType(OPERATION); 
			if(strMode.compare("NORMAL") == 0)
				Nodes[i].task->setMode(NORMAL_MODE);
			else
				if(strMode.compare("SENDER_MODE") == 0)
					Nodes[i].task->setMode(SENDER_MODE);				
			 else
				Nodes[i].task->setMode(RECEIVER_MODE);	
		}
		else{
			
			if(strType.compare("XOR_SPLIT") == 0)
				Nodes[i].task->setType(XOR_SPLIT); 
			else
			if(strType.compare("OR_SPLIT") == 0)
				Nodes[i].task->setType(OR_SPLIT); 
			else
			if(strType.compare("AND_SPLIT") == 0)
				Nodes[i].task->setType(AND_SPLIT); 
			else
			if(strType.compare("XOR_JOIN") == 0)
				Nodes[i].task->setType(XOR_JOIN); 
			else
			if(strType.compare("OR_JOIN") == 0)
				Nodes[i].task->setType(OR_JOIN); 	
			else
			if(strType.compare("AND_JOIN") == 0)
				Nodes[i].task->setType(AND_JOIN); 			
	
			Nodes[i].task->setSrt(0); // The srt for connector is NULL;
			Nodes[i].task->setMode(NORMAL_MODE);	
		}	
	}
	// Read the successors ( we know that there is at least one task without successor
	modfile >> n; // Read the number of tasks for which a sucessor will be defined.

	for(i = 0; i < n; i++){
		modfile >> nc;
		modfile >> id;
		k = 0;
		while(Nodes[k].task->getId() != id)
			k++;
		Nodes[k].succNumber = nc;
		Nodes[k].succs = new BPMNUnitTask*[nc];
		for(j = 0; j < nc; j++){
			modfile >> id;
			l = 0;
			while(Nodes[l].task->getId() != id)
				l++;
			Nodes[k].succs[j] = Nodes[l].task;
			Nodes[l].increasePredNumber();
		}
	}
	// Read the or-Join structure	
	modfile >> n; // number of or/join
	for(i = 0; i < n; i++){
		modfile >> nc >> id;
		k = 0; l =0;
		while(Nodes[k].task->getId() != nc)
			k++;
		while(Nodes[l].task->getId() != id)
			l++;		
		Nodes[k].orSplit = Nodes[l].task;
	}	
	// Read the message costs.
	modfile >> n; // read the number of message connections
	for(i = 0; i < n; i++){
		modfile >> nc >> id;
		k = 0;
		
		while(Nodes[k].task->getId() != id)
			k++;
		Nodes[k].srtTransit = new float[Nodes[k].succNumber];
		
		for(j = 0; j < Nodes[k].succNumber; j++)
			Nodes[k].srtTransit[j] = 0;
				
		for(j = 0; j < nc; j++){
//			cout << "nc = "<< n << "\n ";
			modfile >> id;
			datfile>>srt;
			l = 0;
			while(Nodes[k].succs[l]->getId() != id)
				l++;
						
			Nodes[k].srtTransit[l] = srt;
			l = 0;
			
			while(Nodes[l].task->getId() != id)
				l++;
			Nodes[l].sender = Nodes[k].task; 
		}
	}	
	// Read loop
	modfile >> n; // read the number of loop connectors
	int nl;
	for(i = 0; i < n; i++){
		modfile >> id >> nc;
		datfile >> nl;
		k = 0;
		while(Nodes[k].task->getId() != id)
			k++;
		l = 0;
		while(Nodes[l].task->getId() != nc)
			l++;
		Nodes[k].predLoop = Nodes[l].task;
		Nodes[k].nloop = nl;
		Nodes[l].loop_starter = TRUE;
	}
	modfile.close();
	datfile.close();

}

void OperationGraph :: getOperationNode(OperationNode* ptr){
	int i;
	for(i = 0; i < size; i++){
		ptr[i].task = Nodes[i].task;
		ptr[i].succs = Nodes[i].succs;
		ptr[i].predLoop = Nodes[i].predLoop;
		ptr[i].orSplit = Nodes[i].orSplit;
		ptr[i].sender = Nodes[i].sender;
		ptr[i].nloop = Nodes[i].nloop;
		ptr[i].loop_starter = Nodes[i].loop_starter;
		ptr[i].srtTransit = Nodes[i].srtTransit;
		ptr[i].succNumber = Nodes[i].succNumber;
		ptr[i].predNumber = Nodes[i].predNumber;

	}
}

int OperationGraph :: getSize(){
	return size;
}

void OperationGraph :: compute_Abs_Prob(){
}
