#include <cstdlib>
#include<iostream>
#include "DistSim.h"
using namespace std;


int main(int argc, char* argv[]){
/*
 * argv[1] is the number of request
 * argv[2] is the delta value
 * argv[3] is the name of the file model
 * */
	
	srand(time(NULL));
	DistSim *simulator;
	OperationGraph *Go;
	if(argc < 5){
		cout<< "Not enough arguments \n";
		return -1;
	}	
	string filename1(argv[3]);
	string filename2(argv[4]);
	OperationNode *Nodes;

	simulator = new DistSim;
	Go = new OperationGraph;
	Go->loadGraph((char*)filename1.c_str(), (char*)filename2.c_str());
	Nodes = new OperationNode[Go->getSize()];
	Go->getOperationNode(Nodes);

	simulator->setGraphSize(Go->getSize());
	simulator->setOperationNode(Nodes);
	
	simulator->setRequestNumber(atoi(argv[1]));
	simulator->setDelta(atof(argv[2]));
	simulator->run();

	cout<< "Mean simulation time = " <<simulator->getMeanTime()<<" \n";
	cout<< "Probabilities values : \n";
	int i;
	for(i = 0; i < Go->getSize(); i++)
		cout<< "node "<< Nodes[i].task->getId() << ": " << simulator->getProba(i) << "\n";
	
	return 0;
}
